﻿'
' Copyright (c) 2021, MindFusion LLC - Bulgaria.
'

Imports System.Reflection


Public Class MemberInfoComparer
	Implements IComparer

	Public Sub New()
		_comparer = New Comparer(System.Globalization.CultureInfo.InvariantCulture)
	End Sub

	Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
		Dim xx As MemberInfo = TryCast(x, MemberInfo)
		Dim yy As MemberInfo = TryCast(y, MemberInfo)

		Dim xName As String = xx.Name
		If xx.MemberType = MemberTypes.Constructor Then
			xName = xx.DeclaringType.Name
		End If

		Dim yName As String = yy.Name
		If yy.MemberType = MemberTypes.Constructor Then
			yName = yy.DeclaringType.Name
		End If

		Return _comparer.Compare(xName, yName)
	End Function

	Private _comparer As Comparer

End Class